#include "stdafx.h"
#include "Paint.h"
#include "Globals.h"

Bitmap* pFloor1 = 0;
Bitmap* pWall1 = 0;
CachedBitmap* pcbFloor1 = 0;
CachedBitmap* pcbWall1 = 0;
Bitmap* pGem[8] = {0, 0, 0, 0, 0, 0, 0, 0};
CachedBitmap* pCbGem[8] = {0, 0, 0, 0, 0, 0, 0, 0};
Bitmap* pChar[24] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
CachedBitmap* pCbChar[24] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
Bitmap* pSword[2] = {0, 0};
CachedBitmap* pCbSword[2] = {0, 0};
Bitmap* pKey = 0;
CachedBitmap* pCbFeather = 0;
Bitmap* pFeather = 0;
CachedBitmap* pCbKey = 0;
Bitmap* pOrbs[3] = {0, 0, 0};
CachedBitmap* pCbOrbs[3] = {0, 0, 0};
Bitmap* pBmpGameOver = 0;
CachedBitmap* pCBmpGameOver = 0;
Bitmap* pBmpStairs = 0;
CachedBitmap* pCBmpStairs = 0;
Bitmap* pBmpVictory1 = 0;
CachedBitmap* pCBmpVictory1  = 0;
Bitmap* pBmpVictory2 = 0;
CachedBitmap* pCBmpVictory2  = 0;
Bitmap* pBmpLogo  = 0;
CachedBitmap* pCbBmpLogo  = 0;
Bitmap* pBmpSwordItem  = 0;
CachedBitmap* pCbBmpSwordItem  = 0;

void InitPaint(Graphics* graphics)
{
	pFloor1 = new Bitmap(L"floor1.png");
	pcbFloor1 = new CachedBitmap(pFloor1, graphics);

	pWall1 = new Bitmap(L"wall1.png");
	pcbWall1 = new CachedBitmap(pWall1, graphics);

	pGem[0] = new Bitmap(L"gem1.png");
	pGem[1] = new Bitmap(L"gem2.png");
	pGem[2] = new Bitmap(L"gem3.png");
	pGem[3] = new Bitmap(L"gem4.png");
	pGem[4] = new Bitmap(L"gem5.png");
	pGem[5] = new Bitmap(L"gem6.png");
	pGem[6] = new Bitmap(L"gem7.png");
	pGem[7] = new Bitmap(L"gem8.png");
	for(unsigned int i=0; i<8; i++) pCbGem[i] = new CachedBitmap(pGem[i], graphics);
	
	pChar[0] = new Bitmap(L"frontwalk1.png");
	pChar[1] = new Bitmap(L"frontwalk2.png");
	pChar[2] = new Bitmap(L"frontwalk3.png");
	pChar[3] = new Bitmap(L"backwalk1.png");
	pChar[4] = new Bitmap(L"backwalk2.png");
	pChar[5] = new Bitmap(L"backwalk3.png");
	pChar[6] = new Bitmap(L"lsidewalk1.png");
	pChar[7] = new Bitmap(L"lsidewalk2.png");
	pChar[8] = new Bitmap(L"lsidewalk3.png");
	pChar[9] = new Bitmap(L"rsidewalk1.png");
	pChar[10] = new Bitmap(L"rsidewalk2.png");
	pChar[11] = new Bitmap(L"rsidewalk3.png");
	pChar[12] = new Bitmap(L"frontwalk1_red.png");
	pChar[13] = new Bitmap(L"frontwalk2_red.png");
	pChar[14] = new Bitmap(L"frontwalk3_red.png");
	pChar[15] = new Bitmap(L"backwalk1_red.png");
	pChar[16] = new Bitmap(L"backwalk2_red.png");
	pChar[17] = new Bitmap(L"backwalk3_red.png");
	pChar[18] = new Bitmap(L"lsidewalk1_red.png");
	pChar[19] = new Bitmap(L"lsidewalk2_red.png");
	pChar[20] = new Bitmap(L"lsidewalk3_red.png");
	pChar[21] = new Bitmap(L"rsidewalk1_red.png");
	pChar[22] = new Bitmap(L"rsidewalk2_red.png");
	pChar[23] = new Bitmap(L"rsidewalk3_red.png");
	for(unsigned int i=0; i<24; i++) pCbChar[i] = new CachedBitmap(pChar[i], graphics);

	pKey = new Bitmap(L"key.png");
	pCbKey = new CachedBitmap(pKey, graphics);

	pSword[0] = new Bitmap(L"sword.png");
	pCbSword[0] = new CachedBitmap(pSword[0], graphics);
	pSword[1] = new Bitmap(L"sword_mouseover.png");
	pCbSword[1] = new CachedBitmap(pSword[1], graphics);

	pFeather = new Bitmap(L"feather.png");
	pCbFeather = new CachedBitmap(pFeather, graphics);
	pBmpLogo = new Bitmap(L"logo.png");
	pCbBmpLogo =new CachedBitmap(pBmpLogo, graphics);
	
	pOrbs[0] = new Bitmap(L"white_orb.png");
	pOrbs[1] = new Bitmap(L"blue_orb.png");
	pOrbs[2] = new Bitmap(L"red_orb.png");
	for(unsigned int i=0; i<3; i++) pCbOrbs[i] = new CachedBitmap(pOrbs[i], graphics);

	pBmpGameOver = new Bitmap(L"gameover.png");
	pCBmpGameOver = new CachedBitmap(pBmpGameOver, graphics);
	pBmpStairs = new Bitmap(L"stairs.png");
	pCBmpStairs = new CachedBitmap(pBmpStairs, graphics);
	
	pBmpVictory1 = new Bitmap(L"victory1.png");
	pCBmpVictory1 = new CachedBitmap(pBmpVictory1, graphics);
	pBmpVictory2 = new Bitmap(L"victory2.png");
	pCBmpVictory2 = new CachedBitmap(pBmpVictory2, graphics);
	
	pBmpLogo = new Bitmap(L"logo.png");
	pCbBmpLogo = new CachedBitmap(pBmpLogo, graphics);
	pBmpSwordItem = new Bitmap(L"swordItem.png");
	pCbBmpSwordItem = new CachedBitmap(pBmpSwordItem, graphics);
}

Point ScreenToWorld(float x, float y)
{
	Point world;
	world.X = x + g_globals.cameraX - (g_globals.maxx/2);
	world.Y = y + g_globals.cameraY - (g_globals.maxy/2);
	// say camera is looking at 500, 500 in game world. something appears at position
	// 320, 240 on screen pos, then world 500, 500

	return world;
}

Point WorldToScreen(int x, int y)
{
	Point screen;
	screen.X = -g_globals.cameraX + x + (g_globals.maxx/2);
	screen.Y = -g_globals.cameraY + y + (g_globals.maxy/2);// say camera is positioned at 300. something appears at position 1

	// say camera is looking at 500, 500 in game world.
	// if talking about pos 500, 500, should appear at 320, 240.
	return screen;
}


void SwordBomb::Paint(Graphics& graphics)
{
	SolidBrush transp(Color(127, 255, 255, 255));
	Point screenCoord = WorldToScreen(center.X, center.Y);
	graphics.FillEllipse(&transp, screenCoord.X-explosionRadius, screenCoord.Y-explosionRadius, explosionRadius*2, explosionRadius*2);
	for(unsigned int i=0; i<swords.size(); i++)
	{
		screenCoord = WorldToScreen(swords[i].pos.X, swords[i].pos.Y);
		graphics.DrawCachedBitmap(pCbBmpSwordItem, screenCoord.X, screenCoord.Y-swords[i].height);
	}
}

bool paintInit = false;

void PaintFrame(int maxx, int maxy, Graphics& graphics)
{
	if(!paintInit) {
		InitPaint(&graphics);
		paintInit = true;
	}
	
	Color highlight(136, 144, 80);
	Color mid(17, 19, 3);
	Pen ltGreenPen(highlight, 2);
	SolidBrush panelBrush(mid);
	SolidBrush topBrush(highlight);
	SolidBrush whiteBrush(Color(255, 255, 255));
	Font font(L"Times New Roman", 16);

	if(g_globals.gameState == GAME_OVER)
	{
		std::wstring msg = L"Game over...  (press any key)";
		graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, (INT)g_globals.maxx, (INT)g_globals.maxy);
		graphics.DrawCachedBitmap(pCBmpGameOver, (g_globals.maxx - pBmpGameOver->GetWidth())/2, (g_globals.maxy - pBmpGameOver->GetHeight())/2);
		graphics.DrawString(msg.c_str(), msg.length(), &font, PointF(100, 400), &whiteBrush);
		return;
	}
	else if(g_globals.gameState == VICTORY1)
	{
		graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, (INT)g_globals.maxx, (INT)g_globals.maxy);
		graphics.DrawCachedBitmap(pCBmpVictory1, (g_globals.maxx - pBmpVictory1->GetWidth())/2, (g_globals.maxy - pBmpVictory1->GetHeight())/2);
		std::wstring msg = L"You find the trophy.";
		graphics.DrawString(msg.c_str(), msg.length(), &font, PointF(100, 400), &whiteBrush);
		return;
	}
	else if(g_globals.gameState == VICTORY2)
	{
		graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, (INT)g_globals.maxx, (INT)g_globals.maxy);
		graphics.DrawCachedBitmap(pCBmpVictory2, (g_globals.maxx - pBmpVictory2->GetWidth())/2, (g_globals.maxy - pBmpVictory2->GetHeight())/2);
		std::wstring msg = L"Congratulations!";
		graphics.DrawString(msg.c_str(), msg.length(), &font, PointF(100, 400), &whiteBrush);
		return;
	}
	else if(g_globals.gameState == TUTORIAL)
	{
		std::wstring line1 = L"You are wandering through a dungeon in search of its treasure.";
		std::wstring line2 = L"The four dungeon floors are heavily guarded.";
		std::wstring line3 = L"It is safe to walk through clear orbs,";
		std::wstring line3b = L"or ones that are the same color as yourself.";
		std::wstring line4 = L"But, opposite-colored orbs damage you.";
		std::wstring line5 = L"If you get a gem, you will switch colors.";
		std::wstring line5b = L"You may also find a rare sword-bomb! (can hold 3).";
		std::wstring line5c = L"Use those with the mouse or 'b' key.";
		std::wstring line6 = L"Try to find the exit!";
		graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, (INT)g_globals.maxx, (INT)g_globals.maxy);
		graphics.DrawString(line1.c_str(), line1.length(), &font, PointF(20, 30), &whiteBrush);
		graphics.DrawString(line2.c_str(), line2.length(), &font, PointF(20, 60), &whiteBrush);
		graphics.DrawCachedBitmap(pCbOrbs[1], 20, 90);
		graphics.DrawCachedBitmap(pCbOrbs[2], 80, 90);
		graphics.DrawCachedBitmap(pCbOrbs[0], 170, 90);
		graphics.DrawString(line3.c_str(), line3.length(), &font, PointF(250, 110), &whiteBrush);
		graphics.DrawString(line3b.c_str(), line3b.length(), &font, PointF(250, 140), &whiteBrush);
		graphics.DrawString(line4.c_str(), line4.length(), &font, PointF(20, 200), &whiteBrush);
		graphics.DrawString(line5.c_str(), line5.length(), &font, PointF(20, 230), &whiteBrush);
		graphics.DrawCachedBitmap(pCbGem[0], 400, 230);
		graphics.DrawString(line5b.c_str(), line5b.length(), &font, PointF(20, 260), &whiteBrush);
		graphics.DrawString(line5c.c_str(), line5c.length(), &font, PointF(60, 290), &whiteBrush);
		graphics.DrawCachedBitmap(pCbBmpSwordItem, 500, 240);
		graphics.DrawString(line6.c_str(), line6.length(), &font, PointF(60, 330), &whiteBrush);
		graphics.DrawCachedBitmap(pCBmpStairs, 330, 330);
		
		
		return;
	}
	else if(g_globals.gameState == SPLASH_SCREEN)
	{
		graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, (INT)g_globals.maxx, (INT)g_globals.maxy);
		graphics.DrawCachedBitmap(pCbBmpLogo, (g_globals.maxx - pBmpLogo->GetWidth())/2, (g_globals.maxy - pBmpVictory2->GetHeight())/2);
		//std::wstring msg = L"Congratulations!";
		//graphics.DrawString(msg.c_str(), msg.length(), &font, PointF(100, 400), &whiteBrush);
		
		std::wstring line1 = L"Press any key to start, or";
		std::wstring line2 = L"ESC for a quick tutorial.";
		graphics.DrawString(line1.c_str(), line1.length(), &font, PointF(200, 330), &whiteBrush);
		graphics.DrawString(line2.c_str(), line2.length(), &font, PointF(200, 360), &whiteBrush);
		return;
	}
	// Paint the level.
	// what position in the level is the camera pointing?
	// Try to center the camera on the character.
	// If the camera is too far toward the edge, move it.

	// Point the camera at 0, 0.
	// Try to center the camera on the man!
	g_globals.cameraX = g_globals.myPosX;
	g_globals.cameraY = g_globals.myPosY;
	
	// If camera would go off the map, push it back on.
	if(g_globals.cameraX < g_globals.maxx/2) g_globals.cameraX = g_globals.maxx/2;
	if(g_globals.cameraY < g_globals.maxy/2) g_globals.cameraY = g_globals.maxy/2;
	if(g_globals.cameraX > (g_globals.l.width*g_globals.tileSize) - (g_globals.maxx/2)) {
		g_globals.cameraX = g_globals.l.width*g_globals.tileSize - (g_globals.maxx/2);
	}

	// Iterate thru the worldspace that's visible on the screen.
	SolidBrush redBrush(Color(255, 0, 0));
	SolidBrush blueBrush(Color(0, 0, 255));
	SolidBrush blkBrush(Color(0, 0, 0));
	Point worldTL = ScreenToWorld(0, 0);
	Point worldBR = ScreenToWorld(g_globals.maxx, g_globals.maxy);

	const int tileSize = g_globals.tileSize;
	
	float rad = g_globals.tileSize/3;

	// if cameraX ++, then nudge the map left by 1.
	// but wait, we hopped to a new tile.
	// normal pos = dx is 0
	// camera pts at 1 - dx is -1
	// camera pts at 2 - dx is -2
	
	for(int y = -tileSize; y<g_globals.maxy+tileSize; y+=tileSize)
	{
		for(int x = -tileSize; x<g_globals.maxx+tileSize; x+=tileSize)
		{
			int dx = -(g_globals.cameraX+tileSize-1)%tileSize;
			int dy = -(g_globals.cameraY+tileSize-1)%tileSize;
			Point worldPos = ScreenToWorld(x+dx, y+dy);
			int tileIndexX = (worldPos.X)/tileSize;
			int tileIndexY = (worldPos.Y)/tileSize;
			if(tileIndexX < 0 || tileIndexX >=g_globals.l.width) continue;
			if(tileIndexY < 0 || tileIndexY >=g_globals.l.height) continue;
			unsigned int thisTile = g_globals.l.Get(tileIndexX, tileIndexY);
			if(thisTile == 0)
			{
				// This is a floor tile
				graphics.DrawCachedBitmap(pcbFloor1, x+dx, y+dy);
				//graphics.FillRectangle(&redBrush, x+dx, y+dy, tileSize, tileSize);
				// paint red
			}
			else if(thisTile == 1)
			{
				// This is a wall tile
				graphics.DrawCachedBitmap(pcbWall1, x+dx, y+dy);
				//graphics.FillRectangle(&blueBrush, x+dx, y+dy, tileSize, tileSize);
			}
			else if(thisTile == 2)
			{
				// A staircase tile
				graphics.DrawCachedBitmap(pCBmpStairs, x+dx, y+dy-9);
			}
		}
	}
	
	// If any drops on screen, paint them too
	for(unsigned int i=0; i<g_globals.drops.size(); i++)
	{
		Point& worldPos = g_globals.drops[i].pos;
		Point screenPos = WorldToScreen(worldPos.X, worldPos.Y);
		if(screenPos.X > 0 && screenPos.X < g_globals.maxx &&
			screenPos.Y > 0 && screenPos.Y < g_globals.maxy)
		{
			int id = g_globals.drops[i].id;
			if(id==0) // gem
			{
				graphics.DrawCachedBitmap(pCbGem[g_globals.drops[i].frame], screenPos.X-(rad/2), screenPos.Y-(rad/2));
			}
			else if(id == 1) // sword bomb
			{
				rad = g_globals.tileSize/4;
				graphics.FillEllipse(&whiteBrush, screenPos.X-(rad/2), screenPos.Y-(rad/2), rad*2, rad*2);
				graphics.DrawCachedBitmap(pCbBmpSwordItem, screenPos.X-(rad/2)+8, screenPos.Y-(rad/2));
			}
			//graphics.FillRectangle(&blkBrush, screenPos.X-(rad/2), screenPos.Y-(rad/2), rad*2, rad*2);


		}
	}

	// Draw man
	// Appearance depends on what direction he is facing
	Point myScreenPos = WorldToScreen(g_globals.myPosX, g_globals.myPosY);
	CachedBitmap* myImg;
	int base = 0;
	int inc = 0;
	if(g_globals.myDir == DIR_S) base = 0;
	else if(g_globals.myDir == DIR_N) base = 3;
	else if(g_globals.myDir == DIR_E) base = 6;
	else if(g_globals.myDir == DIR_W) base = 9;
	if(g_globals.myFrameNum == 0) inc = 0;
	else if(g_globals.myFrameNum == 1) inc = 1;
	else if(g_globals.myFrameNum == 2) inc = 0;
	else if(g_globals.myFrameNum == 3) inc = 2;
	if(g_globals.myColor == 2) inc += 12;
	myImg = pCbChar[base+inc];

	graphics.DrawCachedBitmap(myImg, myScreenPos.X-g_globals.tileSize/3, myScreenPos.Y-g_globals.tileSize/2);
	//graphics.FillRectangle(&blkBrush, myScreenPos.X-(rad/2), myScreenPos.Y-(rad/2), rad*2, rad*2);

	
	// If any orbs on screen, paint them
	for(unsigned int i=0; i<g_globals.orbs.size(); i++)
	{
		Orb& orb = g_globals.orbs[i];
		if(orb.dead) continue;
		PointF& worldPos = orb.pos;
		Point screenPos = WorldToScreen(worldPos.X, worldPos.Y);
		if(screenPos.X > -g_globals.tileSize && screenPos.X < 
			g_globals.maxx &&
			screenPos.Y > -g_globals.tileSize && screenPos.Y < g_globals.maxy)
		{
			CachedBitmap* pCbmp = 0;
			if(g_globals.orbs[i].color == 0) pCbmp = pCbOrbs[0]; // white
			else if(g_globals.orbs[i].color == 2) pCbmp = pCbOrbs[2]; // red
			else if(g_globals.orbs[i].color == 4) pCbmp = pCbOrbs[1]; // blue
			else if(g_globals.orbs[i].color == 1) {
				pCbmp = pCbOrbs[0]; // on way to red
				if(orb.majorCountdown < 10) screenPos.X += orb.flicker? -2:2;
			}
			else if(g_globals.orbs[i].color == 3) {
				pCbmp = pCbOrbs[0]; // on way to blue
				if(orb.majorCountdown < 10) screenPos.X += orb.flicker? -2:2;
			}

			graphics.DrawCachedBitmap(pCbmp, screenPos.X-(rad/2), screenPos.Y-(rad/2));
			//graphics.FillRectangle(&blkBrush, screenPos.X-(rad/2), screenPos.Y-(rad/2), rad*2, rad*2);


		}
	}

	// Swordbomb effects
	if(g_globals.swordBomb.inProgress)
		g_globals.swordBomb.Paint(graphics);


	// Draw the border
	// Light top panel
	graphics.FillRectangle(&topBrush, (INT)0, (INT)0, (INT)g_globals.maxx,  5);
	// Dark left panel
	graphics.FillRectangle(&panelBrush, (INT)0, (INT)0, 25,  (INT)g_globals.maxy);

	// Border all around frame
	graphics.DrawRectangle(&ltGreenPen, (INT)0, (INT)0,(INT) g_globals.maxx, (INT)g_globals.maxy);
	// Side bar line
	ltGreenPen.SetWidth(1);
	graphics.DrawLine(&ltGreenPen, (INT)23, (INT)0, (INT)23, (INT)g_globals.maxy);
	// Side bar icons
	if(g_globals.mouseOverSword)
	{
		graphics.DrawCachedBitmap(pCbSword[1], 15, 10);
	}
	else
	{
		graphics.DrawCachedBitmap(pCbSword[0], 15, 10);
	}
	std::wstring text;
	if(g_globals.swordBombCount == 0) text = L"x0";
	else if(g_globals.swordBombCount == 1) text = L"x1";
	else if(g_globals.swordBombCount == 2) text = L"x2";
	else if(g_globals.swordBombCount == 3) text = L"x3";
	graphics.DrawString(text.c_str(), text.length(), &font, PointF(50, 10), &whiteBrush);

	//graphics.DrawCachedBitmap(pCbKey, 15, 60);
	//graphics.DrawCachedBitmap(pCbFeather, 15, 110);

	// Health bar
	const float leftHealthBarMargin = 200;
	const float hborder = 10;
	const float rightHealthBarMargin = 50;
	graphics.DrawString(L"HP:", 4, &font, PointF(150, g_globals.maxy-75), &whiteBrush);
	graphics.FillRectangle(&panelBrush, (INT)(leftHealthBarMargin-hborder), (INT)g_globals.maxy-70,(INT) (g_globals.maxx-leftHealthBarMargin-rightHealthBarMargin+hborder+hborder), (INT)15);

	float healthBarWidth = (g_globals.maxx - leftHealthBarMargin - rightHealthBarMargin) * g_globals.health;
	graphics.FillRectangle(&whiteBrush, (INT)leftHealthBarMargin, (INT)g_globals.maxy-70+5,(INT) (INT)healthBarWidth, (INT)5);
	
	// Put which floor we're on
	std::wstring floorMsg;
	if(g_globals.floorNum == 1) floorMsg = L"Floor F1";
	else if(g_globals.floorNum == 2) floorMsg = L"Floor F2";
	else if(g_globals.floorNum == 3) floorMsg = L"Floor F3";
	else if(g_globals.floorNum == 4) floorMsg = L"Tower";
	graphics.DrawString(floorMsg.c_str(), floorMsg.length(), &font, PointF(500, 5), &whiteBrush);
	
}